## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm
%bcond check 1

# https://github.com/golang/tools
%global goipath         golang.org/x/tools/gopls
%global forgeurl        https://github.com/golang/tools
Version:                0.18.1
%global tag             gopls/v%{version}
%{lua: rpm.define("safe_tag " .. string.gsub(rpm.expand("%tag"), "/", "-"))}
%global distprefix      %{nil}

%gometa -L -f


%global common_description %{expand:
gopls (pronounced "Go please") is the official Go language server developed by
the Go team. It provides IDE features to any LSP-compatible editor.

You should not need to interact with gopls directly--it will be automatically
integrated into your editor. The specific features and settings vary slightly
by editor, so we recommend that you proceed to the documentation for your
editor.}

%global golicenses      LICENSE PATENTS
%global godocs          CONTRIBUTING.md gopls/README.md

Name:           gopls
Release:        %autorelease
Summary:        gopls, the Go language server

License:        BSD-3-Clause
URL:            %{gourl}
Source:         %{gosource}
# We build with GO111MODULE=off so can't test anything in module mode.
Patch:          0001-Skip-tests-that-require-module-mode.patch
# Fix compatibility with latest golang-x-tools.
Patch:          0002-internal-event-export-ocagent-delete.patch

Obsoletes:      golang-x-tools-gopls < 1:0.22.0-3
Provides:       golang-x-tools-gopls = %{version}-%{release}

%description %{common_description}

%prep
%goprep -A
%autopatch -p1
# Created by goprep, but with the wrong path, so re-create it.
rm -r _build/src/golang.org/x/tools
# mkdir -p _build/src/golang.org/x
ln -fs %{_builddir}/tools-%{safe_tag} _build/src/golang.org/x/tools

%generate_buildrequires
%go_generate_buildrequires

%build
%gobuild -o %{gobuilddir}/bin/gopls %{goipath}

%install
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
# Tests expect this to be set because go.mod specifies a new enough Go version,
# but since we disable module mode, this isn't set automatically.
export GODEBUG=gotypesalias=1
%gocheck -t internal/cmd -t internal/lsp/cache -t internal/telemetry
%endif

%files
%license LICENSE PATENTS
%doc CONTRIBUTING.md gopls/README.md
%{_bindir}/gopls

%changelog
## START: Generated by rpmautospec
* Tue May 20 2025 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.18.1-2
- Fix compatibility with latest golang-x-tools

* Mon Feb 24 2025 Packit <hello@packit.dev> - 0.18.1-1
- Update to 0.18.1 upstream release
- Resolves: rhbz#2330899

* Sun Jan 19 2025 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.17.1-1
- Update to latest version (#2330899)

* Sun Jan 19 2025 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.16.2-4
- Add Packit configuration

* Fri Jan 17 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.16.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Nov 26 2024 Mikel Olasagasti Uranga <mikel@olasagasti.info> - 0.16.2-2
- Fix FTBFS with newer golang-x-tools

* Fri Nov 15 2024 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.16.2-1
- import rhbz#2324991
## END: Generated by rpmautospec
